CodeForces 638D Three-dimensional Turtle Super Computer

题意:有一个三维空间,从(x,y,z)的信号可以传输到(x+1,y,z),(x,y+1,z),(x,y,z+1)现在有一些是坏的,就是不能用的然后问你里面有多少个关键点。关键点就是,如果这个坏了,会改变原来的传输信号的过程。假设原来(x,y,z)能够传输到(x1,y1,z1),但是由于坏了(x2,y2,z2),导致不能传输了,就说(x2,y2,z2)是关键的。

思路:暴力出奇迹


#include<bits/stdc++.h>
using namespace std;
int str[120][120][120];
int main()
{
    int n,m,k;
	scanf("%d%d%d",&n,&m,&k);
	for (int i = 1;i<=n;i++)
		for (int j = 1;j<=m;j++)
		{
			string s;
			cin >> s;
			for (int t = 0;t<s.size();t++)
			{
				if (s[t]=='1')
					str[i][j][t+1]=1;
				else
					str[i][j][t+1]=0;
			}
		}
	int ans = 0;
	for (int i = 1;i<=n;i++)
		for (int j = 1;j<=m;j++)
			for (int t = 1;t<=k;t++)
			{
				if (str[i][j][t]){
                if(str[i-1][j][t]&&str[i+1][j][t])ans++;
                else if(str[i][j-1][t]&&str[i][j+1][t])ans++;
                else if(str[i][j][t-1]&&str[i][j][t+1])ans++;
                else if(str[i-1][j][t]&&str[i][j+1][t]&&(!str[i-1][j+1][t]))ans++;
                else if(str[i-1][j][t]&&str[i][j][t+1]&&(!str[i-1][j][t+1]))ans++;
                else if(str[i][j-1][t]&&str[i+1][j][t]&&(!str[i+1][j-1][t]))ans++;
                else if(str[i][j-1][t]&&str[i][j][t+1]&&(!str[i][j-1][t+1]))ans++;
                else if(str[i][j][t-1]&&str[i+1][j][t]&&(!str[i+1][j][t-1]))ans++;
                else if(str[i][j][t-1]&&str[i][j+1][t]&&(!str[i][j+1][t-1]))ans++;

				}
			}
	printf("%d\n",ans);
}

Description

A super computer has been built in the Turtle Academy of Sciences. The computer consists of n·m·k CPUs. The architecture was the paralellepiped of size n × m × k, split into 1 × 1 × 1 cells, each cell contains exactly one CPU. Thus, each CPU can be simultaneously identified as a group of three numbers from the layer number from 1 to n, the line number from 1 to m and the column number from 1to k.

In the process of the Super Computer's work the CPUs can send each other messages by the famous turtle scheme: CPU (x, y, z) can send messages to CPUs (x + 1, y, z)(x, y + 1, z) and (x, y, z + 1) (of course, if they exist), there is no feedback, that is, CPUs (x + 1, y, z)(x, y + 1, z) and (x, y, z + 1) cannot send messages to CPU (x, y, z).

Over time some CPUs broke down and stopped working. Such CPUs cannot send messages, receive messages or serve as intermediates in transmitting messages. We will say that CPU (a, b, c)controls CPU (d, e, f) , if there is a chain of CPUs (xi, yi, zi), such that (x1 = a, y1 = b, z1 = c)(xp = d, yp = e, zp = f) (here and below p is the length of the chain) and the CPU in the chain with number i (i < p) can send messages to CPU i + 1.

Turtles are quite concerned about the denial-proofness of the system of communication between the remaining CPUs. For that they want to know the number of critical CPUs. A CPU (x, y, z) is critical, if turning it off will disrupt some control, that is, if there are two distinctive from (x, y, z) CPUs: (a, b, c) and (d, e, f), such that (a, b, c) controls (d, e, f) before (x, y, z) is turned off and stopped controlling it after the turning off.

Input

The first line contains three integers nm and k (1 ≤ n, m, k ≤ 100) — the dimensions of the Super Computer.

Then n blocks follow, describing the current state of the processes. The blocks correspond to the layers of the Super Computer in the order from 1 to n. Each block consists of m lines, k characters in each — the description of a layer in the format of an m × k table. Thus, the state of the CPU (x, y, z) is corresponded to the z-th character of the y-th line of the block number x. Character "1" corresponds to a working CPU and character "0" corresponds to a malfunctioning one. The blocks are separated by exactly one empty line.

Output

Print a single integer — the number of critical CPUs, that is, such that turning only this CPU off will disrupt some control.

Sample Input

Input
2 2 3
000
000

111
111
Output
2
Input
3 3 3
111
111
111

111
111
111

111
111
111
Output
19
Input
1 1 10
0101010101
Output
0




  • 1
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
CodeForces - 616D是一个关于找到一个序列中最长的第k好子段的起始位置和结束位置的问题。给定一个长度为n的序列和一个整数k,需要找到一个子段,该子段中不超过k个不同的数字。题目要求输出这个序列最长的第k好子段的起始位置和终止位置。 解决这个问题的方法有两种。第一种方法是使用尺取算法,通过维护一个滑动窗口来记录\[l,r\]中不同数的个数。每次如果这个数小于k,就将r向右移动一位;如果已经大于k,则将l向右移动一位,直到个数不大于k。每次更新完r之后,判断r-l+1是否比已有答案更优来更新答案。这种方法的时间复杂度为O(n)。 第二种方法是使用枚举r和双指针的方法。通过维护一个最小的l,满足\[l,r\]最多只有k种数。使用一个map来判断数的种类。遍历序列,如果当前数字在map中不存在,则将种类数sum加一;如果sum大于k,则将l向右移动一位,直到sum不大于k。每次更新完r之后,判断i-l+1是否大于等于y-x+1来更新答案。这种方法的时间复杂度为O(n)。 以上是两种解决CodeForces - 616D问题的方法。具体的代码实现可以参考引用\[1\]和引用\[2\]中的代码。 #### 引用[.reference_title] - *1* [CodeForces 616 D. Longest k-Good Segment(尺取)](https://blog.csdn.net/V5ZSQ/article/details/50750827)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] - *2* [Codeforces616 D. Longest k-Good Segment(双指针+map)](https://blog.csdn.net/weixin_44178736/article/details/114328999)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] [ .reference_list ]

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值